Package: qcmetrics
Type: Package
Title: A Framework for Quality Control
Version: 1.48.0
Authors@R: person(given = "Laurent", family = "Gatto",
                  email = "laurent.gatto@uclouvain.be",
                  role = c("aut","cre"))
Description: The package provides a framework for generic quality
             control of data. It permits to create, manage and
             visualise individual or sets of quality control metrics
             and generate quality control reports in various formats.
Depends: R (>= 3.3)
Imports: Biobase, methods, knitr, tools, xtable, pander, S4Vectors
Suggests: affy, MSnbase, ggplot2, lattice, mzR, BiocStyle, rmarkdown,
        markdown
License: GPL-2
URL: http://lgatto.github.io/qcmetrics/articles/qcmetrics.html
BugReports: https://github.com/lgatto/qcmetrics/issues
biocViews: ImmunoOncology, Software, QualityControl, Proteomics,
        Microarray, MassSpectrometry, Visualization, ReportWriting
VignetteBuilder: knitr
RoxygenNote: 6.1.0
git_url: https://git.bioconductor.org/packages/qcmetrics
git_branch: RELEASE_3_22
git_last_commit: 7058a53
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 05:52:25 UTC; biocbuild
Author: Laurent Gatto [aut, cre]
Maintainer: Laurent Gatto <laurent.gatto@uclouvain.be>

# A General Framework for Quality Control Metrics

## About 

The `qcmetrics` package provides a general framework to develope
quality control (QC) pipelines for any type of data that can be
imported into `R`. The application of `qcmetrics` can be schematised
in 5 points

1. Identify a set of quality metrics of interest and implement them
   and their visualisation method into individual `QcMetric`
   instances.
2. Bundles the `QcMetric` items into a `QcMetrics` instance. 
3. Automatically generate reports in pdf of html using the `qcReport`
   function using the `QcMetrics` object of step 2 as input.
4. Optionally, reports can be customised. 
5. Wrap the above steps into a wrapper function or a new QC package
   for production use.

QC pipelines and packages will be described and disseminated through
the [wiki](https://github.com/lgatto/qcmetrics/wiki).

## Installation

*[qcmetrics](http://bioconductor.org/packages/qcmetrics)* is a Bioconductor package and should in
installed with


```r
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("qcmetrics")
```

## Bugs and question

Either file a
[GitHub issue](https://github.com/lgatto/qcmetrics/issues) or use the
[Bioconductor support forum](https://support.bioconductor.org/).

##' A simple wrapper for the QC of 15N labelling. The respective
##' QC items are the distribution of PSM incorporation rates,
##' distribution of log2 fold-changes and number of identified
##' features. See the vignette for details.
##'
##' @title N15 labelling QC report
##' @param object An \code{MSnSet} to be quality controlled.
##' @param fcol The name of the feature variables for the protein
##'     identifiers (accession numbers for example), the peptide
##'     sequences, the number of unique peptides for each identified
##'     protein, the variable modifications identified on the peptides
##'     and the N15 incorporation rate.  These must be provided in
##'     that order. Defaults are \code{Protein_Accession},
##'     \code{Peptide_Sequence}, \code{Number_Of_Unique_Peptides},
##'     \code{Variable_Modifications}, and \code{inc}.
##' @param inctr The minimum level of median incorporation rate to set
##'     the QC item status to \code{TRUE}. Default is 97.5.
##' @param lfctr The range of accepted median PSM log2 fold-change for
##'     the QC item status to be set to \code{TRUE}.  Default is
##'     \code{c(-0.5, 0.5)}.
##' @param type The type of report to be saved. If missing (default),
##'     no report is generated. See \code{\link{qcReport}} for
##'     details.
##' @param reportname The name of the report, in case a \code{type} is
##'     defined. If missing (default), the report will be names
##'     \code{n15qcreport} followed by the generation data and time.
##' @return Invisibly returns the resulting \code{QcMetrics} instance.
##' @author Laurent Gatto
n15qc <- function(object,
                  fcol = c("Protein_Accession",
                      "Peptide_Sequence",
                      "Number_Of_Unique_Peptides",
                      "Variable_Modifications",
                      "inc"),
                  inctr = 97.5,
                  lfctr = c(-0.5, 0.5),
                  type,
                  reportname) {
    stopifnot(requireNamespace("MSnbase"))
    stopifnot(requireNamespace("Biobase"))
    stopifnot(requireNamespace("ggplot2"))
    stopifnot(inherits(object, "MSnSet"))
    stopifnot(all(fcol %in% MSnbase::fvarLabels(object)))
    
    ## incorporation rate QC metric
    qcinc <- QcMetric(name = "15N incorporation rate")
    qcdata(qcinc, "inc") <- MSnbase::fData(object)[, fcol[5]]
    qcdata(qcinc, "tr") <- inctr
    status(qcinc) <- median(qcdata(qcinc, "inc")) > qcdata(qcinc, "tr")

    show(qcinc) <- function(object) {
        qcshow(object, qcdata = FALSE) 
        cat(" QC threshold:", qcdata(object, "tr"), "\n")
        cat(" Incorporation rate\n")
        print(summary(qcdata(object, "inc")))
        invisible(NULL)
    }
    plot(qcinc) <- function(object) {
        inc <- qcdata(object, "inc")
        tr <- qcdata(object, "tr")
        lab <- "Incorporation rate"
        dd <- data.frame(inc = qcdata(qcinc, "inc"))
        p <- ggplot2::ggplot(dd, ggplot2::aes(factor(""), inc)) +            
             ggplot2::geom_jitter(colour = "#4582B370", size = 3) + 
             ggplot2::geom_boxplot(fill = "#FFFFFFD0",
                                   colour = "#000000", outlier.size = 0) +
             ggplot2::geom_hline(yintercept = tr, colour = "red",
                                 linetype = "dotted", size = 1) +
             ggplot2::labs(x = "", y = "Incorporation rate") 
        p
    }

    ## summarise data
    MSnbase::fData(object)$modseq <- ## pep seq + PTM
        paste(MSnbase::fData(object)[, fcol[2]],
              MSnbase::fData(object)[, fcol[4]], sep = "+")
    pep <- MSnbase::combineFeatures(object,
                                    as.character(MSnbase::fData(object)[, fcol[2]]), 
                                    "median", verbose = FALSE)
    modpep <- MSnbase::combineFeatures(object,
                                       MSnbase::fData(object)$modseq,
                                       "median", verbose = FALSE)
    prot <- MSnbase::combineFeatures(object,
                                     as.character(MSnbase::fData(object)[, fcol[1]]), 
                                     "median", verbose = FALSE)

    ## calculate log fold-change
    qclfc <- QcMetric(name = "Log2 fold-changes")
    qcdata(qclfc, "lfc.psm") <-
        log2(MSnbase::exprs(object)[,"unlabelled"] / MSnbase::exprs(object)[, "N15"])
    qcdata(qclfc, "lfc.pep") <-
        log2(MSnbase::exprs(pep)[,"unlabelled"] / MSnbase::exprs(pep)[, "N15"])
    qcdata(qclfc, "lfc.modpep") <-
        log2(MSnbase::exprs(modpep)[,"unlabelled"] / MSnbase::exprs(modpep)[, "N15"])
    qcdata(qclfc, "lfc.prot") <-
        log2(MSnbase::exprs(prot)[,"unlabelled"] / MSnbase::exprs(prot)[, "N15"])
    qcdata(qclfc, "explfc") <- lfctr
    
    status(qclfc) <-
        median(qcdata(qclfc, "lfc.psm")) > qcdata(qclfc, "explfc")[1] &
            median(qcdata(qclfc, "lfc.psm")) < qcdata(qclfc, "explfc")[2]
    
    show(qclfc) <- function(object) {
        qcshow(object, qcdata = FALSE) 
        cat(" QC thresholds:", qcdata(object, "explfc"), "\n")
        cat(" * PSM log2 fold-changes\n")
        print(summary(qcdata(object, "lfc.psm")))
        cat(" * Modified peptide log2 fold-changes\n")
        print(summary(qcdata(object, "lfc.modpep")))
        cat(" * Peptide log2 fold-changes\n")
        print(summary(qcdata(object, "lfc.pep")))
        cat(" * Protein log2 fold-changes\n")
        print(summary(qcdata(object, "lfc.prot")))    
        invisible(NULL)
    }
    plot(qclfc) <- function(object) {
        x <- qcdata(object, "explfc")
        plot(density(qcdata(object, "lfc.psm")),
             main = "", sub = "", col = "red",
             ylab = "", lwd = 2,
             xlab = expression(log[2]~fold-change))    
        lines(density(qcdata(object, "lfc.modpep")),
              col = "steelblue", lwd = 2)
        lines(density(qcdata(object, "lfc.pep")),
              col = "blue", lwd = 2)
        lines(density(qcdata(object, "lfc.prot")),
              col = "orange")
        abline(h = 0, col = "grey")
        abline(v = 0, lty = "dotted")    
        rect(x[1], -1, x[2], 1, col = "#EE000030",
             border = NA)
        abline(v = median(qcdata(object, "lfc.psm")),
               lty = "dashed", col = "blue")
        legend("topright",
               c("PSM", "Peptides", "Modified peptides", "Proteins"),
               col = c("red", "steelblue", "blue", "orange"), lwd = 2,
               bty = "n")
    }
    
    ## number of features
    qcnb <- QcMetric(name = "Number of features")
    qcdata(qcnb, "count") <- c(
        PSM = nrow(object),
        ModPep = nrow(modpep),
        Pep = nrow(pep),
        Prot = nrow(prot))
    qcdata(qcnb, "peptab") <-
        table(MSnbase::fData(object)[, fcol[2]])
    qcdata(qcnb, "modpeptab") <-
        table(MSnbase::fData(object)$modseq)
    qcdata(qcnb, "upep.per.prot") <- 
        MSnbase::fData(object)[, fcol[3]]
    
    show(qcnb) <- function(object) {
        qcshow(object, qcdata = FALSE)
        print(qcdata(object, "count"))
    }
    plot(qcnb) <- function(object) {
        par(mar = c(5, 4, 2, 1))
        layout(matrix(c(1, 2, 1, 3, 1, 4), ncol = 3))
        barplot(qcdata(object, "count"), horiz = TRUE, las = 2)
        barplot(table(qcdata(object, "modpeptab")),
                xlab = "Modified peptides")
        barplot(table(qcdata(object, "peptab")),
                xlab = "Peptides")
        barplot(table(qcdata(object, "upep.per.prot")),
                xlab = "Unique peptides per protein ")
    }

    qcm <- QcMetrics(qcdata = list(qcinc, qclfc, qcnb))    
    metadata(qcm) <- list(File = MSnbase::fileNames(object),
                          Experiment = Biobase::experimentData(object))                          
    if (!missing(type)) {
        if (missing(reportname))
            reportname <- paste("n15qcreport",
                                format(Sys.time(), "%Y-%m-%d-%H:%M:%S"),
                                sep = "_")
        qcReport(qcm, reportname, type = type,                 
                 title = "15N Quality Control")
    }
    invisible(qcm)
}

QcMetrics <- setClass("QcMetrics",
         slots = list(
             metadata = "QcMetadata",
             qcdata = "list"),
         validity = function(object) {
             msg <- validMsg(NULL, NULL)
             cls <- unique(sapply(object@qcdata, class))             
             if (cls != "QcMetric")
                 msg <- validMsg(msg, "Metrics must all be of class 'QcMetric'.")
             if (is.null(msg)) TRUE
             else msg
         })

setMethod("show", "QcMetrics",
          function(object) {
              cat("Object of class \"", class(object), "\"\n", sep="")
              n <- length(qcdata(object))
              m <- length(mdata(object))
              if (n == 0) n <- "no"
              if (m == 0) m <- "no"                  
              cat(" containing", n, "QC metrics.\n")
              cat(" and", m, "metadata variables.\n")              
          })

setMethod("status", "QcMetrics",
          function(object) sapply(qcdata(object), status))

setReplaceMethod("status", signature(object="QcMetrics", value="logical"),
                 function(object, value) {
                     if (length(object) != length(value))
                         stop("The length of the statuses must be equal to the number of QC items.")
                     l <- qcdata(object)
                     for (i in seq_along(value))
                         status(l[[i]]) <- value[i]
                     qcdata(object) <- l
                     object
                 })

as.data.frame.QcMetrics <-
    function(x, row.names=NULL, optional=FALSE, ...) as(x,"data.frame")    

setMethod("qcdata", "QcMetrics",
          function(object, x = "missing") object@qcdata)

setReplaceMethod("qcdata",
                 signature(object="QcMetrics", value="list"),
                 function(object, value) {
                     object@qcdata <- value
                     object
                 })

setMethod("metadata", "QcMetrics",
          function(x) metadata(x@metadata))

setMethod("mdata", "QcMetrics",
          function(object) metadata(object))

setReplaceMethod("metadata",
                 signature(x="QcMetrics", value="list"),
                 function(x, value) {
                     checkMetaDataListNames(value)
                     oldmd <- x@metadata@metadata
                     oldnms <- names(oldmd)                     
                     newnms <- names(value)
                     l <- unique(c(oldnms, newnms))
                     finalmd <- vector(mode = "list", length = length(l))
                     names(finalmd) <- l
                     finalmd[oldnms] <- oldmd
                     finalmd[newnms] <- value
                     checkMetaDataListNames(finalmd)
                     value <- QcMetadata(metadata = finalmd)
                     metadata(x) <- value
                     x
                 })

setReplaceMethod("mdata",
                 signature(object="QcMetrics", value="list"),
                 function(object, value) {
                     metadata(object) <- value
                     object
                 })

setReplaceMethod("metadata",
                 signature(x="QcMetrics", value="QcMetadata"),
                 function(x, value) {
                     x@metadata <- value
                     x
                 })

setReplaceMethod("mdata",
                 signature(object="QcMetrics", value="QcMetadata"),
                 function(object, value) {
                     object@metadata <- value
                     object
                 })

setMethod("[","QcMetrics",
          function(x, i="numeric", j="missing", drop="missing") {
              x@qcdata <- x@qcdata[i]
              x
        })


setMethod("[[","QcMetrics",
          function(x, i="numeric", j="missing" ,drop="missing") 
          x@qcdata[[i]])


setMethod("name", "QcMetrics",
          function(object) sapply(qcdata(object), name))

setMethod("length", "QcMetrics",
          function(x) length(qcdata(x)))

setAs("QcMetrics", "data.frame",
      function (from) {
          data.frame(name = name(from),
                     status = status(from))
      })

.QcMetadata <- setClass("QcMetadata",
                        slots = list(metadata = "list"))

checkMetaDataListNames <- function(metadata) {
    nms <- names(metadata)
    if (is.null(nms)) 
        stop("Your metadata must be named.")    
    nonms <- (nms == "") | is.na(nms)
    if (any(nonms))
        stop("Empty names or NA are not permitted.")
    return(TRUE)
}

QcMetadata <- function(metadata) {
    stopifnot(class(metadata) == "list")
    checkMetaDataListNames(metadata)
    .QcMetadata(metadata = metadata)
}

setMethod("show", "QcMetadata",
          function(object) {
              cat("Object of class \"", class(object), "\"\n", sep="")
              n <- length(object@metadata)
              if (n == 0) n <- "no"
              cat(" containing", n , "variables.\n")              
          })

setMethod("print", "QcMetadata",
          function(x) {
              x <- metadata(x)
              nms <- names(x)
              if (is.null(nms))
                  nms <- paste0("Metadata ", 1:length(x))
              for (i in seq_along(x)) {        
                  cat(nms[i], "\n ")
                  print(x[[i]])        
              }
          })

setMethod("metadata", "QcMetadata",
          function(x) x@metadata)

setMethod("mdata", "QcMetadata",
          function(object) metadata(object))

setReplaceMethod("metadata",
                 signature(x="QcMetadata", value="list"),
                 function(x, value) {
                     x@metadata <- value
                     x
                 })

setReplaceMethod("mdata",
                 signature(object="QcMetadata", value="list"),
                 function(object, value) {
                     object@metadata <- value
                     object
                 })

setMethod("length", "QcMetadata",
          function(x) length(mdata(x)))

setMethod("[","QcMetadata",
          function(x, i="numeric", j="missing", drop="missing") {
              x@metadata <- x@metadata[i]
              x
        })


setMethod("[[","QcMetadata",
          function(x, i="numeric", j="missing" ,drop="missing") 
          x@metadata[[i]])

setMethod("names", "QcMetadata",
          function(x) names(x@metadata))

setReplaceMethod("names",
                 signature(x="QcMetadata", value="character"),
                 function(x, value) {
                     names(x@metadata) <- value
                     x
                 })

example_reports <- function(report = c("protqc",
                                       "n15qc",
                                       "custom",
                                       "rnadeg")) {
    report <- match.arg(report, several.ok = FALSE)
    dir(system.file("reports", package = "qcmetrics"),
        pattern = report, full.names = TRUE)
}

library("RforProteomics")
msfile <- getPXD000001mzXML()
library("MSnbase")
exp0 <- readMSData(msfile, verbose = FALSE)

exp <- exp0[seq(1, length(exp0), by = 3)]
save(exp, file = "~/dev/00_github/qcmetrics/inst/extdata/exp.rda",
     compress = "xz", compression_level = 9)

reporting_rmd <- function(object,
                          reportname = reportname,
                          author = author,
                          title = title,
                          meta = meta,
                          summary = summary,
                          sessioninfo = sessioninfo,
                          qcto) {
    if (is.null(qcto))
        qcto <- Qc2Rmd
    ext <- "Rmd"
    out <- paste(reportname, ext, sep = ".")
    con <- file(out, "w")
    on.exit(close(con))
    title <- sub("qcmetrics", "`qcmetrics`", title)
    title <- paste0("", title,
                    "\n===========================================\n\n")
    author <- paste0("Author: ", author, "\n")
    .date <- paste0("Date: ", date(), "\n\n")
    writeLines(c(title, author, .date), con)
    if (meta)
        writeLines(metadata_rmd(object@metadata), con)
    for (i in 1:length(object))
        writeLines(qcto(object, i),
                   con)
    if (summary) {
        writeLines("QC summary", con)
        writeLines("-----------------------------\n", con)
        smry <- c("```{r echo=FALSE}",
                  "library('pander')",
                  "pandoc.table(as(object, 'data.frame'))",
                  "```")
        writeLines(smry, con)
    }
    if (sessioninfo) {
        si <- c("Session information",
                "-------------------------\n",
                "```{r echo=FALSE}",
                "sessionInfo()",
                "```")
        writeLines(si, con)
    }
    return(out)
}

reporting_html <- function(object,
                           reportname = reportname,
                           author = author,
                           title = title,
                           meta = meta,
                           summary = summary,
                           sessioninfo = sessioninfo,
                           clean = clean,
                           quiet = quiet,
                           qcto) {
    if (is.null(qcto))
        qcto <- Qc2Rmd
    ext <- "Rmd"
    out <- paste(reportname, ext, sep = ".")
    con <- file(out, "w")
    title <- sub("qcmetrics", "`qcmetrics`", title)
    title <- paste0("", title,
                    "\n===========================================\n\n")
    author <- paste0("Author: ", author, "\n")
    .date <- paste0("Date: ", date(), "\n\n")
    writeLines(c(title, author, .date), con)
    if (meta)
        writeLines(metadata_rmd(object@metadata), con)
    for (i in 1:length(object))
        writeLines(qcto(object, i),
                   con)
    if (summary) { ## only difference with Rmd type
        writeLines("QC summary", con)
        writeLines("-----------------------------\n", con)
        writeLines(print(xtable(as(object, 'data.frame')),
                         type = 'html',
                         print.results = FALSE),
                   con)
    }
    if (sessioninfo)
        writeLines(c("Session information",
                     "-------------------------\n",
                     "```{r echo=FALSE}",
                     "sessionInfo()",
                     "```"),
                   con)
    close(con)
    ## procude html
    ext <- "html"
    out <- knit2html(out,
                     output = paste(reportname, ext, sep = "."),
                     quiet = quiet)
    if (clean) {
        unlink(paste(reportname, "Rmd", sep = "."))
        unlink(paste(reportname, "md", sep = "."))
    }
    return(out)
}

reporting_pdf <- function(object,
                          reportname = reportname,
                          author = author,
                          title = title,
                          meta = meta,
                          toc = toc,
                          summary = summary,
                          sessioninfo = sessioninfo,
                          clean = clean,
                          quiet = clean,
                          qcto,
                          ...) {
    if (is.null(qcto))
        qcto <- Qc2Tex
    out <- reporting_tex(object,
                         reportname = reportname,
                         author = author,
                         title = title,
                         meta = meta,
                         toc = toc,
                         summary = summary,
                         sessioninfo = sessioninfo,
                         quiet = quiet,
                         qcto = qcto)
    ext <- "pdf"
    tools::texi2pdf(out, quiet = quiet, clean = clean, ...)
    out <- paste(reportname, ext, sep = ".")
    if (clean) {
        file.remove(paste0(reportname, ".tex"))
        unlink("figure", recursive = TRUE)
    }
    moved <- file.rename(paste(basename(reportname), ext, sep = "."), out)
    return(out)
}

reporting_tex <- function(object,
                          reportname = reportname,
                          author = author,
                          title = title,
                          meta = meta,
                          toc = toc,
                          summary = summary,
                          sessioninfo = sessioninfo,
                          ## clean -  no tex files cleaning
                          quiet = quiet,
                          qcto) {
    if (is.null(qcto))
        qcto <- Qc2Tex
    ext <- "tex"
    template <- system.file("templates", "knitr-template.Rnw",
                            package = "qcmetrics")
    parent <- c('<<parent, include = FALSE>>=',
                paste0('set_parent("', template , '")'),
                '@')
    title <- sub("qcmetrics", "\\\\texttt{qcmetrics}", title)
    mktitle <- "\\maketitle"
    if (toc) {
        toc <- paste0('\\tableofcontents',
                      '\\newpage')
    } else {
        toc <- ''
    }
    mtd <- c()
    if (meta) mtd <- c(metadata_tex(object@metadata),
                       "\\newpage")
    ex <- lapply(seq_len(length(object)),
                 function(i) qcto(object, i))
    ex <- append(list(mktitle, toc, parent, mtd), ex)
    if (summary)
        ex <- append(ex,
                     c("\\clearpage",
                       "\\section{QC summary}",
                       "<<summary, results = 'asis', echo = FALSE>>=",
                       "library('xtable')",
                       "xtable(as(object, 'data.frame'))",
                       "@"))
    if (sessioninfo)
        ex <- append(ex,
                     list(c("\\section{Session information}",
                            "<<session-info, cache=FALSE, results = 'asis', echo=FALSE>>=",
                            "toLatex(sessionInfo())",
                            "@")))
    ## generate tex file
    opts_knit$set(out.format = "latex")
    out <- knit(text = unlist(ex),
                output = paste0(reportname, ".tex"),
                quiet = quiet)
    ## TODO also move figure directory
    return(out)
}


Qc2Rmd <- function(object, i) {
    c(paste0("", name(object[[i]]),
             "\n-------------------------\n"),
      paste0("```{r ", name(object[[i]]), ", echo=FALSE}"),
      paste0("show(object[[", i, "]])"),
      "```",
      "```{r, echo=FALSE, fig.width=5, fig.height=5, fig.align='left'}",
      paste0("plot(object[[", i, "]])"),
      "```")
}

Qc2Tex <- function(object, i) {
    c(paste0("\\section{", name(object[[i]]), "}"),
      paste0("<<", name(object[[i]]), ", echo=FALSE>>="),
      paste0("show(object[[", i, "]])"),
      "@\n",
      "\\begin{figure}[!hbt]",
      "<<dev='pdf', echo=FALSE, fig.width=5, fig.height=5, fig.align='center'>>=",
      paste0("plot(object[[", i, "]])"),
      "@",
      "\\end{figure}",
      "\\clearpage")
}



Qc2Tex2 <- function(object, i) {
    nm <- name(object[[i]])
    if (is.na(status(object[[i]]))) {
        symb <- "$\\Circle$"
    } else if (status(object[[i]])) {
        symb <- "{\\color{green} $\\CIRCLE$}"
    } else {
        symb <- "{\\color{red} $\\CIRCLE$}"
    }
    sec <- paste0("\\section{", nm,
                  "\\hspace{2mm}", symb, "}")
    cont <- c(paste0("<<", name(object[[i]]), ", echo=FALSE>>="),
              paste0("show(object[[", i, "]])"),
              "@\n",
              "\\begin{figure}[!hbt]",
              "<<dev='pdf', echo=FALSE, fig.width=5, fig.height=5, fig.align='center'>>=",
              paste0("plot(object[[", i, "]])"),
              "@",
              "\\end{figure}",
              "\\clearpage")
    c(sec, cont)
}

Qc2Tex3 <- function(object, i) {
    nm <- name(object[[i]])
    if (is.na(status(object[[i]]))) {
        symb <- "$\\Circle$"
    } else if (status(object[[i]])) {
        symb <- "{\\color{green} $\\smiley$}"
    } else {
        symb <- "{\\color{red} $\\frownie$}"
    }
    sec <- paste0("\\section{", nm,
                  "\\hspace{2mm}", symb, "}")
    cont <- c(paste0("<<", name(object[[i]]), ", echo=FALSE>>="),
              paste0("show(object[[", i, "]])"),
              "@\n",
              "\\begin{figure}[!hbt]",
              "<<dev='pdf', echo=FALSE, fig.width=5, fig.height=5, fig.align='center'>>=",
              paste0("plot(object[[", i, "]])"),
              "@",
              "\\end{figure}",
              "\\clearpage")
    c(sec, cont)
}


metadata_rmd <-
    metadata_html <- function(object) {
        stopifnot(class(object) == "QcMetadata")
        mdsec <- c("Metadata",
                   "-----------------------------\n")
        n <- length(object)
        if (is.null(names(object)))
            names(object) <-
                paste0("Metadata ", 1:n)
        for (i in seq_len(n)) {
            if (is.vector(metadata(object)[[i]])) {
                mdsec <- c(mdsec,
                           paste0("- **", names(object)[i], "** ",
                                  paste0(object[[i]], collapse = " ")))
            } else {
                mdsec <- c(mdsec,
                           paste0("- **", names(object)[i], "**"),
                           "```{r echo=FALSE}",
                           paste0("mdata(object)[[", i, "]]"),
                           "```")
            }
        }
        c(mdsec, "\n")
    }

metadata_tex <-
    metadata_pdf <- function(object) {
        stopifnot(class(object) == "QcMetadata")
        mdsec <- "\\section{Metadata}\n"
        n <- length(object)
        if (is.null(names(object)))
            names(object) <-
                paste0("Metadata ", 1:n)
        mdsec <- c(mdsec, "\\begin{description}")
        for (i in seq_len(n)) {
            if (is.vector(metadata(object)[[i]])) {
                mdsec <- c(mdsec,
                           paste0("\\item[",
                                  names(object)[i], "] ",
                                  paste0(object[[i]], collapse = " ")))
            } else {
                mdsec <- c(mdsec,
                           paste0("\\item[", names(object)[i], "]\\"),
                           '<<echo=FALSE>>=',
                           paste0("mdata(object)[[", i, "]]"),
                           "@")
            }
        }
        c(mdsec, "\\end{description}")
    }

## ----env, include=FALSE, echo=FALSE, cache=FALSE------------------------------
suppressPackageStartupMessages(library("qcmetrics"))
suppressPackageStartupMessages(library("mzR"))
suppressPackageStartupMessages(library("MSnbase"))
set.seed(1)

## ----qcmetric-----------------------------------------------------------------
library("qcmetrics")
qc <- QcMetric(name = "A test metric")
qcdata(qc, "x") <- rnorm(100)
qcdata(qc) ## all available qcdata
summary(qcdata(qc, "x")) ## get x
show(qc) ## or just qc
status(qc) <- TRUE
qc

## ----qcmetricplot-------------------------------------------------------------
plot(qc)
plot(qc) <- function(object, ... ) boxplot(qcdata(object, "x"), ...)
plot(qc)

## -----------------------------------------------------------------------------
qcm <- QcMetrics(qcdata = list(qc))
qcm
metadata(qcm) <- list(author = "Prof. Who",
                      lab = "Big lab")
qcm
mdata(qcm)

## -----------------------------------------------------------------------------
metadata(qcm) <- list(author = "Prof. Who",
                      lab = "Cabin lab",
                      University = "Universe-ity")
mdata(qcm)

## ----eval = FALSE-------------------------------------------------------------
# library("RforProteomics")
# msfile <- getPXD000001mzXML()
# library("MSnbase")
# exp <- readMSData(msfile, verbose = FALSE)

## -----------------------------------------------------------------------------
load(system.file("extdata/exp.rda", package = "qcmetrics"))

## ----protqc1------------------------------------------------------------------
qc1 <- QcMetric(name = "Chromatogram")
x <- rtime(exp)
y <- precursorIntensity(exp)
o <- order(x)
qcdata(qc1, "x") <- x[o]
qcdata(qc1, "y") <- y[o]
plot(qc1) <- function(object, ...)
    plot(qcdata(object, "x"),
         qcdata(object, "y"),
         col = "darkgrey", type ="l",
         xlab = "retention time",
         ylab = "precursor intensity")

## ----protqc2, cache = TRUE----------------------------------------------------
qc2 <- QcMetric(name = "MS space")
qcdata(qc2, "p2d") <- plot2d(exp, z = "charge", plot = FALSE)
plot(qc2) <- function(object) {
    require("ggplot2")
    print(qcdata(object, "p2d"))
}

## ----protqc3, cache = TRUE----------------------------------------------------
qc3 <- QcMetric(name = "m/z delta plot")
qcdata(qc3, "pmz") <- plotMzDelta(exp, plot = FALSE,
                                  verbose = FALSE)
plot(qc3) <- function(object)
    suppressWarnings(print(qcdata(object, "pmz")))

## ----protqcm------------------------------------------------------------------
protqcm <- QcMetrics(qcdata = list(qc1, qc2, qc3))
metadata(protqcm) <- list(
    data = "PXD000001",
    instrument = experimentData(exp)@instrumentModel,
    source = experimentData(exp)@ionSource,
    analyser = experimentData(exp)@analyser,
    detector = experimentData(exp)@detectorType,
    manufacurer = experimentData(exp)@instrumentManufacturer)

## ----protreport0, echo = FALSE, message = FALSE, eval = FALSE-----------------
# qcReport(protqcm, reportname = "protqc", clean=FALSE, quiet=TRUE)

## ----protreport, eval = FALSE-------------------------------------------------
# qcReport(protqcm, reportname = "protqc")

## ----results='markup', out.width="100%", fig.align="center", fig.cap="Proteomics QC report", echo=FALSE----
knitr::include_graphics("./figs/protqc.png")

## ----eval = FALSE-------------------------------------------------------------
# browseURL(example_reports("protqc"))

## ----n15ex--------------------------------------------------------------------
library("ggplot2")
library("MSnbase")
data(n15psm)
psm

## ----qcinc--------------------------------------------------------------------
## incorporation rate QC metric
qcinc <- QcMetric(name = "15N incorporation rate")
qcdata(qcinc, "inc") <- fData(psm)$inc
qcdata(qcinc, "tr") <- 97.5
status(qcinc) <- median(qcdata(qcinc, "inc")) > qcdata(qcinc, "tr")

## ----qcinc2-------------------------------------------------------------------
show(qcinc) <- function(object) {
    qcshow(object, qcdata = FALSE)
    cat(" QC threshold:", qcdata(object, "tr"), "\n")
    cat(" Incorporation rate\n")
    print(summary(qcdata(object, "inc")))
    invisible(NULL)
}

## ----qcinc3-------------------------------------------------------------------
plot(qcinc) <- function(object) {
    inc <- qcdata(object, "inc")
    tr <- qcdata(object, "tr")
    lab <- "Incorporation rate"
    dd <- data.frame(inc = qcdata(qcinc, "inc"))
    p <- ggplot(dd, aes(factor(""), inc)) +
        geom_jitter(colour = "#4582B370", size = 3) +
    geom_boxplot(fill = "#FFFFFFD0", colour = "#000000",
                 outlier.size = 0) +
    geom_hline(yintercept = tr, colour = "red",
               linetype = "dotted", size = 1) +
    labs(x = "", y = "Incorporation rate")
    p
}

## ----combinefeatures----------------------------------------------------------
fData(psm)$modseq <- ## pep seq + PTM
    paste(fData(psm)$Peptide_Sequence,
          fData(psm)$Variable_Modifications, sep = "+")
pep <- combineFeatures(psm,
                       as.character(fData(psm)$Peptide_Sequence),
                       "median", verbose = FALSE)
modpep <- combineFeatures(psm,
                          fData(psm)$modseq,
                          "median", verbose = FALSE)
prot <- combineFeatures(psm,
                        as.character(fData(psm)$Protein_Accession),
                        "median", verbose = FALSE)

## ----qclfc--------------------------------------------------------------------
## calculate log fold-change
qclfc <- QcMetric(name = "Log2 fold-changes")
qcdata(qclfc, "lfc.psm") <-
    log2(exprs(psm)[,"unlabelled"] / exprs(psm)[, "N15"])
qcdata(qclfc, "lfc.pep") <-
    log2(exprs(pep)[,"unlabelled"] / exprs(pep)[, "N15"])
qcdata(qclfc, "lfc.modpep") <-
    log2(exprs(modpep)[,"unlabelled"] / exprs(modpep)[, "N15"])
qcdata(qclfc, "lfc.prot") <-
    log2(exprs(prot)[,"unlabelled"] / exprs(prot)[, "N15"])
qcdata(qclfc, "explfc") <- c(-0.5, 0.5)

status(qclfc) <-
    median(qcdata(qclfc, "lfc.psm")) > qcdata(qclfc, "explfc")[1] &
    median(qcdata(qclfc, "lfc.psm")) < qcdata(qclfc, "explfc")[2]

## ----qclfc2-------------------------------------------------------------------
show(qclfc) <- function(object) {
    qcshow(object, qcdata = FALSE) ## default
    cat(" QC thresholds:", qcdata(object, "explfc"), "\n")
    cat(" * PSM log2 fold-changes\n")
    print(summary(qcdata(object, "lfc.psm")))
    cat(" * Modified peptide log2 fold-changes\n")
    print(summary(qcdata(object, "lfc.modpep")))
    cat(" * Peptide log2 fold-changes\n")
    print(summary(qcdata(object, "lfc.pep")))
    cat(" * Protein log2 fold-changes\n")
    print(summary(qcdata(object, "lfc.prot")))
    invisible(NULL)
}
plot(qclfc) <- function(object) {
    x <- qcdata(object, "explfc")
    plot(density(qcdata(object, "lfc.psm")),
         main = "", sub = "", col = "red",
         ylab = "", lwd = 2,
         xlab = expression(log[2]~fold-change))
    lines(density(qcdata(object, "lfc.modpep")),
          col = "steelblue", lwd = 2)
    lines(density(qcdata(object, "lfc.pep")),
          col = "blue", lwd = 2)
    lines(density(qcdata(object, "lfc.prot")),
          col = "orange")
    abline(h = 0, col = "grey")
    abline(v = 0, lty = "dotted")
    rect(x[1], -1, x[2], 1, col = "#EE000030",
         border = NA)
    abline(v = median(qcdata(object, "lfc.psm")),
           lty = "dashed", col = "blue")
    legend("topright",
           c("PSM", "Peptides", "Modified peptides", "Proteins"),
           col = c("red", "steelblue", "blue", "orange"), lwd = 2,
           bty = "n")
}

## ----qcnb---------------------------------------------------------------------
## number of features
qcnb <- QcMetric(name = "Number of features")
qcdata(qcnb, "count") <- c(
    PSM = nrow(psm),
    ModPep = nrow(modpep),
    Pep = nrow(pep),
    Prot = nrow(prot))
qcdata(qcnb, "peptab") <-
    table(fData(psm)$Peptide_Sequence)
qcdata(qcnb, "modpeptab") <-
    table(fData(psm)$modseq)
qcdata(qcnb, "upep.per.prot") <-
    fData(psm)$Number_Of_Unique_Peptides

## ----qcnb2--------------------------------------------------------------------
show(qcnb) <- function(object) {
    qcshow(object, qcdata = FALSE)
    print(qcdata(object, "count"))
}
plot(qcnb) <- function(object) {
    par(mar = c(5, 4, 2, 1))
    layout(matrix(c(1, 2, 1, 3, 1, 4), ncol = 3))
    barplot(qcdata(object, "count"), horiz = TRUE, las = 2)
    barplot(table(qcdata(object, "modpeptab")),
            xlab = "Modified peptides")
    barplot(table(qcdata(object, "peptab")),
            xlab = "Peptides")
    barplot(table(qcdata(object, "upep.per.prot")),
            xlab = "Unique peptides per protein ")
}

## ----n15qcm-------------------------------------------------------------------
n15qcm <- QcMetrics(qcdata = list(qcinc, qclfc, qcnb))

## ----n15report, eval = FALSE--------------------------------------------------
# qcReport(n15qcm, reportname = "n15qcreport",
#          title = expinfo(experimentData(psm))["title"],
#          author = expinfo(experimentData(psm))["contact"],
#          clean = FALSE)

## ----results='markup', out.width="100%", fig.align="center", fig.cap="N15 QC report", echo=FALSE----
knitr::include_graphics("./figs/n15qcreport.png")

## ----eval = FALSE-------------------------------------------------------------
# browseURL(example_reports("n15qc"))

## ----Qc2Tex-------------------------------------------------------------------
qcmetrics:::Qc2Tex
qcmetrics:::Qc2Tex(n15qcm, 1)

## ----maqcreport4, eval = FALSE------------------------------------------------
# qcReport(n15qcm, reportname = "report", qcto = Qc2Tex2)
# qcReport(n15qcm, reportname = "report", qcto = Qc2Tex3) ## for smiley/frowney

## ----results='markup', out.width="100%", fig.cap="Customised QC report", echo=FALSE----
knitr::include_graphics("./figs/custom.png")

## ----eval = FALSE-------------------------------------------------------------
# browseURL(example_reports("custom"))

## ----qcpkg0, eval=FALSE-------------------------------------------------------
# package.skeleton("N15QC", list = "n15qc")

## ----si-----------------------------------------------------------------------
sessionInfo()

setGeneric("status", function(object) standardGeneric("status"))
setGeneric("status<-", function(object, value) standardGeneric("status<-"))

setGeneric("name", function(object) standardGeneric("name"))
setGeneric("name<-", function(object, value) standardGeneric("name<-"))

setGeneric("qcenv", function(object) standardGeneric("qcenv"))
setGeneric("qcenv<-", function(object, value) standardGeneric("qcenv<-"))
setGeneric("qcdata", function(object, x) standardGeneric("qcdata"))
setGeneric("qcdata<-", function(object, ..., value) standardGeneric("qcdata<-"))

## setGeneric("metadata", function(object, ...) standardGeneric("metadata"))
## setGeneric("metadata<-", function(object, value) standardGeneric("metadata<-"))
setGeneric("mdata", function(object, ...) standardGeneric("mdata"))
setGeneric("mdata<-", function(object, value) standardGeneric("mdata<-"))

setGeneric("show<-", function(object, value) standardGeneric("show<-"))
setGeneric("plot<-", function(object, value) standardGeneric("plot<-"))

setGeneric("qcReport", function(object, ...) standardGeneric("qcReport"))

setMethod("qcReport", "QcMetrics",
          function(object,
                   reportname = "qcreport",
                   type = c("pdf", "tex", "Rmd", "html"),
                   author = Sys.getenv("USER"),
                   title = "Quality control report generated with qcmetrics",
                   meta = length(mdata(object)) > 0,
                   toc = FALSE,
                   summary = TRUE,
                   sessioninfo = TRUE,
                   clean = TRUE,
                   quiet = TRUE,
                   reporter,
                   qcto = NULL,
                   ...) {
              if (length(object) == 0) {
                  message("Empty 'QcMetrics' input. No report generated")
                  return(NULL)
              }
              type <- match.arg(type)
              if (!missing(reporter)) {
                  out <- reporter
              } else {
                  ## dump all current knitr settings and restore them afterwards
                  opts <-
                      c("knit_hooks", "opts_chunk", "opts_hooks", "opts_knit")
                  vals <-
                      sapply(opts, function (name)
                          .subset2(get(name), "get")())
                  on.exit(mapply(
                      function(name, vals)
                          .subset2(get(name), "restore")(vals),
                      opts,
                      vals,
                      SIMPLIFY = FALSE,
                      USE.NAMES = FALSE
                  ),
                  add = TRUE)

                  ## reset to knitr defaults
                  lapply(opts, function(name)
                      .subset2(get(name), "restore")())

                  out <- switch(type,
                                Rmd = reporting_rmd(object, reportname,
                                    author, title, meta,
                                    summary, sessioninfo,
                                    qcto),
                                html = reporting_html(object, reportname,
                                    author, title, meta,
                                    summary, sessioninfo,
                                    clean, quiet, qcto),
                                tex = reporting_tex(object, reportname,
                                    author, title, meta,
                                    toc, summary, sessioninfo,
                                    quiet, qcto),
                                pdf = reporting_pdf(object, reportname,
                                    author, title, meta,
                                    toc, summary, sessioninfo,
                                    clean, quiet, qcto, ...))
              }
              message("Report written to ", out)
              invisible(out)
          })

qcshow <- function(object, qcdata = TRUE) {
    cat("Object of class \"", class(object), "\"\n", sep="")
    cat(" Name:", object@name, "\n")
    if (length(object@description)) {
        cat (" Description:\n")
        writeLines(strwrap(paste(object@description, collapse = " ")))
    }
    cat(" Status:", object@status, "\n")
    if (qcdata) {
        cat(" Data: ")
        if (length(qcdata(object)) == 0) cat("empty\n")
        else cat(qcdata(object), "\n")
    }
    invisible(NULL)
}


.QcMetric <- setClass("QcMetric",
                      slots = list(
                          name = "character",
                          description = "character",
                          qcdata = "environment",
                          plot = "function",
                          show = "function",
                          status = "logical"),
                      prototype = prototype(
                          name = "A QcMetric prototype",
                          status = NA,
                          qcdata = new.env(parent=emptyenv()),
                          plot = function(x, ...) {
                              warning("No specific plot function defined")
                              invisible(NULL)
                          },
                          show = qcshow))

QcMetric <- function(...) {
    ans <- .QcMetric(...)
    ans@qcdata <- new.env(parent=emptyenv())
    ans@name <- ans@name[1]
    ans
}

setMethod("show", "QcMetric",
          function(object) object@show(object))

setReplaceMethod("show",
                 signature(object="QcMetric", value="function"),
                 function(object, value) {
                     object@show <- value
                     return(object)
                 })

setMethod("plot", c("QcMetric", "missing"),
          function(x, y, ...) x@plot(x, ...))

setReplaceMethod("plot",
                 signature(object="QcMetric", value="function"),
                 function(object, value) {
                     object@plot <- value
                     object
                 })

setMethod("qcenv", c("QcMetric"),
          function(object) object@qcdata)

setReplaceMethod("qcenv",
                 signature(object="QcMetric", value="environment"),
                 function(object, value) {
                     object@qcdata <- value
                     object
                 })


setMethod("qcdata", c("QcMetric", "missing"),
          function(object) ls(object@qcdata))

setMethod("qcdata", c("QcMetric", "character"),
          function(object, x) {
              objs <- qcdata(object)
              if (!x %in% objs)
                  stop("No qcdata '", x, "' in object.")
              get(x, envir = object@qcdata)
          })

setReplaceMethod("qcdata",
                 signature(object="QcMetric", value="ANY"),
                 function(object, var, value) {
                     objs <- qcdata(object)
                     if (var %in% objs)
                         message("Overwriting variable 'var'.")
                     assign(var,
                            value = value,
                            envir = object@qcdata)
                     object
                 })

setMethod("status", "QcMetric",
          function(object) object@status)

setReplaceMethod("status", signature(object="QcMetric", value="logical"),
                 function(object, value) {
                     object@status <- value
                     object
                 })

setMethod("name", "QcMetric",
          function(object) object@name)

setReplaceMethod("name", signature(object="QcMetric", value="character"),
                 function(object, value) {
                     object@name <- value
                     object
                 })

setMethod("description", "QcMetric",
          function(object) object@description)

setReplaceMethod("description", signature(object="QcMetric", value="character"),
                 function(object, value) {
                     object@description <- value
                     object
                 })

---
title: "Index file for the qcmetrics package vignette"
author: Laurent Gatto
package: qcmetrics
abstract: >
  The `qcmetrics` package is a framework that
  provides simple data containers for quality metrics and support for
  automatic report generation. This document briefly illustrates the
  core data structures and then demonstrates the generation and
  automation of quality control reports for microarray and proteomics
  data.
output:
  BiocStyle::html_document:
    toc_float: true
bibliography: qcmetrics.bib
vignette: >
  %\VignetteIndexEntry{Index file for the qcmetrics package vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteKeywords{Bioinformatics, proteomics, genomics, transcriptomics, mass-spectrometry, Quality control, reporting}
  %\VignetteEncoding{UTF-8}
---


```{r env, include=FALSE, echo=FALSE, cache=FALSE}
suppressPackageStartupMessages(library("qcmetrics"))
suppressPackageStartupMessages(library("mzR"))
suppressPackageStartupMessages(library("MSnbase"))
set.seed(1)
```


# Introduction {#sec:intro}

Quality control (QC) is an essential step in any analytical
process. Data of poor quality can at best lead to the absence of
positive results or, much worse, false positives that stem from
uncaught faulty and noisy data and much wasted resources in pursuing
red herrings.

Quality is often a relative concept that depends on the nature of the
biological sample, the experimental settings, the analytical process
and other factors. Research and development in the area of QC has
generally lead to two types of work being disseminated. Firstly, the
comparison of samples of variable quality and the identification of
metrics that correlate with the quality of the data. These quality
metrics could then, in later experiments, be used to assess their
quality. Secondly, the design of domain-specific software to
facilitate the collection, visualisation and interpretation of various
QC metrics is also an area that has seen much development. QC is a
prime example where standardisation and automation are of great
benefit. While a great variety of QC metrics, software and pipelines
have been described for any assay commonly used in modern biology, we
present here a different tool for QC, whose main features are
flexibility and versatility. The `qcmetrics` package is a general
framework for QC that can accommodate any type of data. It provides a
flexible framework to implement QC items that store relevant QC
metrics with a specific visualisation mechanism. These individual
items can be bundled into higher level QC containers that can be
readily used to generate reports in various formats. As a result, it
becomes easy to develop complete custom pipelines from scratch and
automate the generation of reports. The pipelines can be easily
updated to accommodate new QC items of better visualisation
techniques.

Section \@ref(sec:qcclasses) provides an overview of the framework. In
section \@ref(sec:pipeline), we use proteomics data (subsection
\@ref(sec:prot)) to demonstrate the elaboration of QC pipelines: how
to create individual QC objects, how to bundle them to create sets of
QC metrics and how to generate reports in multiple formats. We also
show how the above steps can be fully automated through simple wrapper
functions. Although kept simple in the interest of time and space,
these examples are meaningful and relevant. In section
\@ref(sec:report), we provide more detail about the report generation
process, how reports can be customised and how new exports can be
contributed. We proceed in section \@ref(sec:qcpkg) to the
consolidation of QC pipelines using R and elaborate on the development
of dedicated QC packages with `qcmetrics`.

# The QC classes {#sec:qcclasses}

The package provides two types of QC containers. The `QcMetric` class
stores data and visualisation functions for single metrics. Several
such metrics can be bundled into `QcMetrics` instances, that can be
used as input for automated report generation. Below, we will provide
a quick overview of how to create respective `QcMetric` and
`QcMetrics` instances. More details are available in the corresponding
documentations.

## The `QcMetric` class

A QC metric is composed of a description (`name` in the code chunk
below), some QC data (`qcdata`) and a `status` that defines if the
metric is deemed of acceptable quality (coded as `TRUE`), bad quality
(coded as `FALSE`) or not yet evaluated (coded as `NA`). Individual
metrics can be displayed as a short textual summary or plotted. To do
the former, one can use the default `show` method.

```{r qcmetric}
library("qcmetrics")
qc <- QcMetric(name = "A test metric")
qcdata(qc, "x") <- rnorm(100)
qcdata(qc) ## all available qcdata
summary(qcdata(qc, "x")) ## get x
show(qc) ## or just qc
status(qc) <- TRUE
qc
```

Plotting `QcMetric` instances requires to implement a plotting method
that is relevant to the data at hand. We can use a `plot` replacement
method to define our custom function. The code inside the `plot` uses
`qcdata` to extract the relevant QC data from `object` that is then
passed as argument to `plot` and uses the adequate visualisation to
present the QC data.


```{r qcmetricplot}
plot(qc)
plot(qc) <- function(object, ... ) boxplot(qcdata(object, "x"), ...)
plot(qc)
```

## The `QcMetrics` class

A `QcMetrics` object is essentially just a list of individual
\Robject{QcMetric} instances. It is also possible to set a list of
metadata variables to describe the source of the QC metrics. The
metadata can be passed as an `QcMetadata` object (the way it is stored
in the `QcMetrics` instance) or directly as a named `list`. The
`QcMetadata` is itself a `list` and can be accessed and set with
`metadata` or `mdata`. When accessed, it is returned and displayed as
a `list`.

```{r}
qcm <- QcMetrics(qcdata = list(qc))
qcm
metadata(qcm) <- list(author = "Prof. Who",
                      lab = "Big lab")
qcm
mdata(qcm)
```

The metadata can be updated with the same interface. If new named
items are passed, the metadata is updated by addition of the new
elements. If a named item is already present, its value gets updated.

```{r}
metadata(qcm) <- list(author = "Prof. Who",
                      lab = "Cabin lab",
                      University = "Universe-ity")
mdata(qcm)
```

The `QcMetrics` can then be passed to the `qcReport` method to
generate reports, as described in more details below.


# Creating QC pipelines {#sec:pipeline}

## Microarray degradation {#sec:marray}

The Microarray degradation section has been removed since the packages
it was depending on have been deprecated.

## Proteomics raw data {#sec:prot}

To illustrate a simple QC analysis for proteomics data, we will
download data set `PXD00001` from the ProteomeXchange repository in
the mzXML format [@Pedrioli:2004]. The MS2 spectra from that
mass-spectrometry run are then read into Rand stored as an `MSnExp`
experiment using the `readMSData` function from the `MSnbase` package
[@Gatto:2012].

```{r, eval = FALSE}
library("RforProteomics")
msfile <- getPXD000001mzXML()
library("MSnbase")
exp <- readMSData(msfile, verbose = FALSE)
```

In the interest of time, this code chunk has been pre-computed
and a subset (1 in 3) of the `exp` instance is distributed with
the package. The data is loaded with

```{r}
load(system.file("extdata/exp.rda", package = "qcmetrics"))
```

The `QcMetrics` will consist of 3 items, namely a chromatogram
constructed with the MS2 spectra precursor's intensities, a figure
illustrating the precursor charges in the MS space and an m/z delta
plot illustrating the suitability of MS2 spectra for identification
(see `?plotMzDelta` or [@Foster:2011]).

```{r protqc1}
qc1 <- QcMetric(name = "Chromatogram")
x <- rtime(exp)
y <- precursorIntensity(exp)
o <- order(x)
qcdata(qc1, "x") <- x[o]
qcdata(qc1, "y") <- y[o]
plot(qc1) <- function(object, ...)
    plot(qcdata(object, "x"),
         qcdata(object, "y"),
         col = "darkgrey", type ="l",
         xlab = "retention time",
         ylab = "precursor intensity")
```


```{r protqc2, cache = TRUE}
qc2 <- QcMetric(name = "MS space")
qcdata(qc2, "p2d") <- plot2d(exp, z = "charge", plot = FALSE)
plot(qc2) <- function(object) {
    require("ggplot2")
    print(qcdata(object, "p2d"))
}
```

```{r protqc3, cache = TRUE}
qc3 <- QcMetric(name = "m/z delta plot")
qcdata(qc3, "pmz") <- plotMzDelta(exp, plot = FALSE,
                                  verbose = FALSE)
plot(qc3) <- function(object)
    suppressWarnings(print(qcdata(object, "pmz")))
```

Note that we do not store the raw data in any of the above instances,
but always pre-compute the necessary data or plots that are then
stored as `qcdata`. If the raw data was to be needed in multiple
`QcMetric` instances, we could re-use the same `qcdata` *environment*
to avoid unnecessary copies using `qcdata(qc2) <- qcenv(qc1)` and
implement different views through custom `plot` methods.

Let's now combine the three items into a `QcMetrics` object, decorate
it with custom metadata using the MIAPE information from the `MSnExp`
object and generate a report.

```{r protqcm}
protqcm <- QcMetrics(qcdata = list(qc1, qc2, qc3))
metadata(protqcm) <- list(
    data = "PXD000001",
    instrument = experimentData(exp)@instrumentModel,
    source = experimentData(exp)@ionSource,
    analyser = experimentData(exp)@analyser,
    detector = experimentData(exp)@detectorType,
    manufacurer = experimentData(exp)@instrumentManufacturer)
```

<!-- Running this one with echoing so that the auxiliary files,  -->
<!-- in particular the figure directory does not get deleted, as  -->
<!-- it is also created and needed by the vignette itself. -->

```{r protreport0, echo = FALSE, message = FALSE, eval = FALSE}
qcReport(protqcm, reportname = "protqc", clean=FALSE, quiet=TRUE)
```

The status column of the summary table is empty as we have not set the
QC items statuses yet.

```{r protreport, eval = FALSE}
qcReport(protqcm, reportname = "protqc")
```


```{r, results='markup', out.width="100%", fig.align="center", fig.cap="Proteomics QC report", echo=FALSE}
knitr::include_graphics("./figs/protqc.png")
```

The complete pdf report is available with:

```{r, eval = FALSE}
browseURL(example_reports("protqc"))
```


## Processed N15 labelling data {#sec:n15}

In this section, we describe a set of N15 metabolic labelling QC
metrics [@Krijgsveld:2003]. The data is a phospho-enriched N15
labelled *Arabidopsis thaliana* sample prepared as described in
[@Groen:2013]. The data was processed with in-house tools and is
available as an `MSnSet` instance. Briefly, MS2 spectra were search
with the Mascot engine and identification scores adjusted with Mascot
Percolator. Heavy and light pairs were then searched in the survey
scans and N15 incorporation was estimated based on the peptide
sequence and the isotopic envelope of the heavy member of the pair
(the `inc` feature variable). Heavy and light peptides isotopic
envelope areas were finally integrated to obtain unlabelled and N15
quantitation data. The `psm` object provides such data for PSMs
(peptide spectrum matches) with a posterior error probability < 0.05
that can be uniquely matched to proteins.

We first load the `MSnbase` package (required to support the `MSnSet`
data structure) and example data that is distributed with the
`qcmetrics` package. We will make use of the `ggplot2` plotting
package.


```{r n15ex}
library("ggplot2")
library("MSnbase")
data(n15psm)
psm
```

The first QC item examines the N15 incorporation rate, available in
the `inc` feature variable. We also defined a median incorporation
rate threshold `tr` equal to 97.5 that is used to set the QC status.

```{r qcinc}
## incorporation rate QC metric
qcinc <- QcMetric(name = "15N incorporation rate")
qcdata(qcinc, "inc") <- fData(psm)$inc
qcdata(qcinc, "tr") <- 97.5
status(qcinc) <- median(qcdata(qcinc, "inc")) > qcdata(qcinc, "tr")
```

Next, we implement a custom `show` method, that prints 5 summary
values of the variable's distribution.

```{r qcinc2}
show(qcinc) <- function(object) {
    qcshow(object, qcdata = FALSE)
    cat(" QC threshold:", qcdata(object, "tr"), "\n")
    cat(" Incorporation rate\n")
    print(summary(qcdata(object, "inc")))
    invisible(NULL)
}
```



We then define the metric's `plot` function that represent the
distribution of the PSM's incorporation rates as a boxplot, shows all
the individual rates as jittered dots and represents the `tr`
threshold as a dotted red line.

```{r qcinc3}
plot(qcinc) <- function(object) {
    inc <- qcdata(object, "inc")
    tr <- qcdata(object, "tr")
    lab <- "Incorporation rate"
    dd <- data.frame(inc = qcdata(qcinc, "inc"))
    p <- ggplot(dd, aes(factor(""), inc)) +
        geom_jitter(colour = "#4582B370", size = 3) +
    geom_boxplot(fill = "#FFFFFFD0", colour = "#000000",
                 outlier.size = 0) +
    geom_hline(yintercept = tr, colour = "red",
               linetype = "dotted", size = 1) +
    labs(x = "", y = "Incorporation rate")
    p
}
```

N15 experiments of good quality are characterised by high
incorporation rates, which allow to deconvolute the heavy and light
peptide isotopic envelopes and accurate quantification.

The second metric inspects the log2 fold-changes of the PSMs, unique
peptides with modifications, unique peptide sequences (not taking
modifications into account) and proteins. These respective data sets
are computed with the `combineFeatures` function (see
`?combineFeatures` for details).

```{r combinefeatures}
fData(psm)$modseq <- ## pep seq + PTM
    paste(fData(psm)$Peptide_Sequence,
          fData(psm)$Variable_Modifications, sep = "+")
pep <- combineFeatures(psm,
                       as.character(fData(psm)$Peptide_Sequence),
                       "median", verbose = FALSE)
modpep <- combineFeatures(psm,
                          fData(psm)$modseq,
                          "median", verbose = FALSE)
prot <- combineFeatures(psm,
                        as.character(fData(psm)$Protein_Accession),
                        "median", verbose = FALSE)
```

The log2 fold-changes for all the features are then computed and
stored as QC data of our next QC item. We also store a pair of values
`explfc` that defined an interval in which we expect our median PSM
log2 fold-change to be.

```{r qclfc}
## calculate log fold-change
qclfc <- QcMetric(name = "Log2 fold-changes")
qcdata(qclfc, "lfc.psm") <-
    log2(exprs(psm)[,"unlabelled"] / exprs(psm)[, "N15"])
qcdata(qclfc, "lfc.pep") <-
    log2(exprs(pep)[,"unlabelled"] / exprs(pep)[, "N15"])
qcdata(qclfc, "lfc.modpep") <-
    log2(exprs(modpep)[,"unlabelled"] / exprs(modpep)[, "N15"])
qcdata(qclfc, "lfc.prot") <-
    log2(exprs(prot)[,"unlabelled"] / exprs(prot)[, "N15"])
qcdata(qclfc, "explfc") <- c(-0.5, 0.5)

status(qclfc) <-
    median(qcdata(qclfc, "lfc.psm")) > qcdata(qclfc, "explfc")[1] &
    median(qcdata(qclfc, "lfc.psm")) < qcdata(qclfc, "explfc")[2]
```

As previously, we provide a custom `show` method that displays summary
values for the four fold-changes. The `plot` function illustrates the
respective log2 fold-change densities and the expected median PSM
fold-change range (red rectangle). The expected 0 log2 fold-change is
shown as a dotted black vertical line and the observed median PSM
value is shown as a blue dashed line.

```{r qclfc2}
show(qclfc) <- function(object) {
    qcshow(object, qcdata = FALSE) ## default
    cat(" QC thresholds:", qcdata(object, "explfc"), "\n")
    cat(" * PSM log2 fold-changes\n")
    print(summary(qcdata(object, "lfc.psm")))
    cat(" * Modified peptide log2 fold-changes\n")
    print(summary(qcdata(object, "lfc.modpep")))
    cat(" * Peptide log2 fold-changes\n")
    print(summary(qcdata(object, "lfc.pep")))
    cat(" * Protein log2 fold-changes\n")
    print(summary(qcdata(object, "lfc.prot")))
    invisible(NULL)
}
plot(qclfc) <- function(object) {
    x <- qcdata(object, "explfc")
    plot(density(qcdata(object, "lfc.psm")),
         main = "", sub = "", col = "red",
         ylab = "", lwd = 2,
         xlab = expression(log[2]~fold-change))
    lines(density(qcdata(object, "lfc.modpep")),
          col = "steelblue", lwd = 2)
    lines(density(qcdata(object, "lfc.pep")),
          col = "blue", lwd = 2)
    lines(density(qcdata(object, "lfc.prot")),
          col = "orange")
    abline(h = 0, col = "grey")
    abline(v = 0, lty = "dotted")
    rect(x[1], -1, x[2], 1, col = "#EE000030",
         border = NA)
    abline(v = median(qcdata(object, "lfc.psm")),
           lty = "dashed", col = "blue")
    legend("topright",
           c("PSM", "Peptides", "Modified peptides", "Proteins"),
           col = c("red", "steelblue", "blue", "orange"), lwd = 2,
           bty = "n")
}
```

A good quality experiment is expected to have a tight distribution
centred around 0. Major deviations would indicate incomplete
incorporation, errors in the respective amounts of light and heavy
material used, and a wide distribution would reflect large variability
in the data.

Our last QC item inspects the number of features that have been
identified in the experiment. We also investigate how many peptides
(with or without considering the modification) have been observed at
the PSM level and the number of unique peptides per protein. Here, we
do not specify any expected values as the number of observed features
is experiment specific; the QC status is left as `NA`.


```{r qcnb}
## number of features
qcnb <- QcMetric(name = "Number of features")
qcdata(qcnb, "count") <- c(
    PSM = nrow(psm),
    ModPep = nrow(modpep),
    Pep = nrow(pep),
    Prot = nrow(prot))
qcdata(qcnb, "peptab") <-
    table(fData(psm)$Peptide_Sequence)
qcdata(qcnb, "modpeptab") <-
    table(fData(psm)$modseq)
qcdata(qcnb, "upep.per.prot") <-
    fData(psm)$Number_Of_Unique_Peptides
```

The counts are displayed by the new `show` and plotted as bar charts
by the `plot` methods.


```{r qcnb2}
show(qcnb) <- function(object) {
    qcshow(object, qcdata = FALSE)
    print(qcdata(object, "count"))
}
plot(qcnb) <- function(object) {
    par(mar = c(5, 4, 2, 1))
    layout(matrix(c(1, 2, 1, 3, 1, 4), ncol = 3))
    barplot(qcdata(object, "count"), horiz = TRUE, las = 2)
    barplot(table(qcdata(object, "modpeptab")),
            xlab = "Modified peptides")
    barplot(table(qcdata(object, "peptab")),
            xlab = "Peptides")
    barplot(table(qcdata(object, "upep.per.prot")),
            xlab = "Unique peptides per protein ")
}
```


In the code chunk below, we combine the 3 QC items into a `QcMetrics`
instance and generate a report using meta data extracted from the
`psm` `MSnSet` instance.

```{r n15qcm}
n15qcm <- QcMetrics(qcdata = list(qcinc, qclfc, qcnb))
```


```{r n15report, eval = FALSE}
qcReport(n15qcm, reportname = "n15qcreport",
         title = expinfo(experimentData(psm))["title"],
         author = expinfo(experimentData(psm))["contact"],
         clean = FALSE)
```

Once an appropriate set of quality metrics has been identified, the
generation of the `QcMetrics` instances can be wrapped up for
automation.

We provide such a wrapper function for this examples: the `n15qc`
function fully automates the above pipeline. The names of the feature
variable columns and the thresholds for the two first QC items are
provided as arguments. In case no report name is given, a custom title
with date and time is used, to avoid overwriting existing reports.

```{r, results='markup', out.width="100%", fig.align="center", fig.cap="N15 QC report", echo=FALSE}
knitr::include_graphics("./figs/n15qcreport.png")
```

The complete pdf report is available with

```{r, eval = FALSE}
browseURL(example_reports("n15qc"))
```

# Report generation {#sec:report}


The report generation is handled by dedicated packages, in particular
`knitr` [@Xie:2013] and `markdown` [@markdown].

## Custom reports


<!-- ### Templates -->

<!-- It is possible to customise reports for any of the existing types. The -->
<!-- generation of the pdf report is based on a `tex` template, -->
<!-- `knitr-template.Rnw`, that is available with the package (you can find -->
<!-- it with `system.file("templates", "knitr-template.Rnw", package = -->
<!-- "qcmetrics")`). The `qcReport` method accepts the path to a custom -->
<!-- `template` as argument. -->

<!-- The template corresponds to a LaTeX preamble with the inclusion of two -->
<!-- variables that are passed to the `qcReport` and used to customise the -->
<!-- template: the author's name and the title of the report. The former is -->
<!-- defaulted to the system username with `Sys.getenv("USER")` and the -->
<!-- later is a simple character. The `qcReport` function also -->
<!-- automatically generates summary and session information sections. The -->
<!-- core of the QC report, i.e the sections corresponding the the -->
<!-- individual `QcMetric` instances bundled in a `QcMetrics` input -->
<!-- (described in more details below) is then inserted into the template -->
<!-- and weaved, or more specifically `knit`'ted into a tex document that -->
<!-- is (if `type=pdf`) compiled into a pdf document. -->

<!-- The generation of the html report is enabled by the creation of a R -->
<!-- markdown file (Rmd) that is then converted with `knitr` and `markdown` -->
<!-- into html. The Rmd syntax being much simpler, no Rmd template is -->
<!-- needed. It is possible to customise the final html output by providing -->
<!-- a css definition as `template` argument when calling `qcReport`. -->

### QcMetric sections

The generation of the sections for `QcMetric` instances is controlled
by a function passed to the `qcto` argument. This function takes care
of transforming an instance of class `QcMetric` into a character that
can be inserted into the report. For the tex and pdf reports, `Qc2Tex`
is used; the Rmd and html reports make use of Qc2Rmd. These functions
take an instance of class `QcMetrics` and the index of the `QcMetric`
to be converted.

```{r Qc2Tex}
qcmetrics:::Qc2Tex
qcmetrics:::Qc2Tex(n15qcm, 1)
```

Let's investigate how to customise these sections depending on the
`QcMetric` status, the goal being to highlight positive QC results
(i.e. when the status is `TRUE`) with green circles (or smileys),
negative results with red cirlces (or frownies) and use en empty black
circle if status is `NA` after the section title (the respective
symbols are from the LaTeX package `wasysym`).


```{rQc2Tex2}
Qc2Tex2
```

To use this specific sectioning code, we pass our new function as
`qcto` when generating the report. To generate smiley labels, use
`Qc2Tex3`.


```{r maqcreport4, eval = FALSE}
qcReport(n15qcm, reportname = "report", qcto = Qc2Tex2)
qcReport(n15qcm, reportname = "report", qcto = Qc2Tex3) ## for smiley/frowney
```


```{r, results='markup', out.width="100%", fig.cap="Customised QC report", echo=FALSE}
knitr::include_graphics("./figs/custom.png")
```

The complete pdf report is available with:

```{r, eval = FALSE}
browseURL(example_reports("custom"))
```


## New report types


A reporting function is a function that


- Converts the appropriate QC item sections (for example the
  `Qc2Tex2` function described above).

- Optionally includes the QC item sections into addition header and
  footer, either by writing these directly or by inserting the
  sections into an appropriate template. The reporting functions that
  are available in `qcmetrics` can be found in `?qcReport`:
  `reporting_tex` for type tex, `reporting\_pdf` for type `pdf`,
  ... These functions should use the same arguments as `qcReport`
  insofar as possible.

- Once written to a report source file, the final report type is
  generated. `knit` is used to convert the Rnw source to tex which is
  compiled into pdf using `tools::texi2pdf`. The Rmd content is
  directly written into a file which is knitted and converted to html
  using `knit2html` (which call `markdownTOHTML`).

New `reporting_abc` functions can be called directly or passed to
`qcReport` using the `reporter` argument.


## QC packages {#sec:qcpkg}

While the examples presented in section \@ref(sec:pipeline) are
flexible and fast ways to design QC pipeline prototypes, a more robust
mechanism is desirable for production pipelines. The R packaging
mechanism is ideally suited for this as it provides versioning,
documentation, unit testing and easy distribution and installation
facilities.

While the detailed description of package development is out of the
scope of this document, it is of interest to provide an overview of
the development of a QC package. Taking the wrapper function, it could
be used the create the package structure

```{r qcpkg0, eval=FALSE}
package.skeleton("N15QC", list = "n15qc")
```

The `DESCRIPTION` file would need to be updated. The packages
`qcmetrics`, and `MSnbas` would need to be specified as dependencies
in the `Imports:` line and imported in the `NAMESPACE` file. The
documentation file `N15QC/man/n15qc.Rd` and the (optional)
\texttt{N15QC/man/n15pq-packge.Rd} would need to be updated.
q

# Conclusions {#sec:ccl}

R and Bioconductor are well suited for the analysis of high throughput
biology data. They provide first class statistical routines, excellent
graph capabilities and an interface of choice to import and manipulate
various omics data, as demonstrated by the wealth of packages that
provide [functionalities for
QC](http://bioconductor.org/packages/release/BiocViews.html#___QualityControl).

The `qcmetrics` package is different than existing R packages and QC
systems in general. It proposes a unique domain-independent framework
to design QC pipelines and is thus suited for any use case. The
examples presented in this document illustrated the application of
`qcmetrics` on data containing single or multiple samples or
experimental runs from different technologies. It is also possible to
automate the generation of QC metrics for a set of repeated (and
growing) analyses of standard samples to establish *lab memory* types
of QC reports, that track a set of metrics for controlled standard
samples over time. It can be applied to raw data or processed data and
tailored to suite precise needs. The popularisation of integrative
approaches that combine multiple types of data in novel ways stresses
out the need for flexible QC development.

`qcmetrics` is a versatile software that allows rapid and easy QC
pipeline prototyping and development and supports straightforward
migration to production level systems through its well defined
packaging mechanism.


**Acknowledgements**: Many thanks to Arnoud Groen for providing the
N15 data and Andrzej Oles for helpful comments and suggestions about
the package and this document.

# Session information {#sec:sessionInfo}

All software and respective versions used to produce this document are
listed below.

```{r si}
sessionInfo()
```
# References

\name{n15qc}
\alias{n15qc}
\title{N15 labelling QC report}
\usage{
  n15qc(object,
    fcol = c("Protein_Accession", "Peptide_Sequence", "Number_Of_Unique_Peptides", "Variable_Modifications", "inc"),
    inctr = 97.5, lfctr = c(-0.5, 0.5), type, reportname)
}
\arguments{
  \item{object}{An \code{MSnSet} to be quality controlled.}

  \item{fcol}{The name of the feature variables for the
  protein identifiers (accession numbers for example), the
  peptide sequences, the number of unique peptides for each
  identified protein, the variable modifications identified
  on the peptides and the N15 incorporation rate. These
  must be provided in that order. Defaults are
  \code{Protein_Accession}, \code{Peptide_Sequence},
  \code{Number_Of_Unique_Peptides},
  \code{Variable_Modifications}, and \code{inc}.}

  \item{inctr}{The minimum level of median incorporation
  rate to set the QC item status to \code{TRUE}. Default is
  97.5.}

  \item{lfctr}{The range of accepted median PSM log2
  fold-change for the QC item status to be set to
  \code{TRUE}. Default is \code{c(-0.5, 0.5)}.}

  \item{type}{The type of report to be saved. If missing
  (default), no report is generated. See
  \code{\link{qcReport}} for details.}

  \item{reportname}{The name of the report, in case a
  \code{type} is defined. If missing (default), the report
  will be names \code{n15qcreport} followed by the
  generation data and time.}
}
\value{
  Invisibly returns the resulting \code{QcMetrics}
  instance.
}
\description{
  A simple wrapper for the QC of 15N labelling. The
  respective QC items are the distribution of PSM
  incorporation rates, distribution of log2 fold-changes
  and number of identified features. See the vignette for
  details.
}
\author{
  Laurent Gatto
}

\name{psm}
\alias{psm}
\alias{n15psm}
\docType{data}

\title{ 15N example data }

\description{
  An example data for 15N metabolic labelling, distributed as an
  \code{MSnSet} to illustrate 15N QC. }

\usage{data(n15psm)}

\references{
  See \code{MSnSet} and the \code{MSnbase-demo} vignette in the
  \code{MSnbase} package.
}

\examples{
library("MSnbase")
data(n15psm)
psm
}

\keyword{datasets}

\name{QcMetadata-class}
\Rdversion{1.1}
\docType{class}
\alias{QcMetadata-class}
\alias{class:QcMetadata}
\alias{QcMetadata}
\alias{metadata,QcMetadata-method}
\alias{metadata<-,QcMetadata,list-method}
\alias{mdata<-,QcMetadata,list-method}
\alias{mdata,QcMetadata-method}
\alias{show,QcMetadata-method}
\alias{print,QcMetadata-method}
\alias{length,QcMetadata-method}
\alias{[,QcMetadata-method}
\alias{[[,QcMetadata-method}
\alias{names,QcMetadata-method}
\alias{names<-,QcMetadata,character-method}

\title{The \code{"QcMetadata"} class}

\description{
  The \code{QcMetadata} class is a simple interface to metadata. The
  objects can be displayed with \code{show} for a summary and
  \code{print} for the content.
}


\section{Objects from the Class}{
  Objects can be created by calls of the form \code{QcMetadata(...)}.
}

\section{Slots}{
  \describe{
    \item{\code{metadata}:}{Object of class \code{"list"} that stores
      the metadata variables. The list must be named. \code{NA} and
      empty characters are not allowed. }
  }
}

\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "QcMetadata")}: subsets \code{x} as a
      new \code{QcMetadata} instance. }
    \item{[[}{\code{signature(x = "QcMetadata")}: extracts a single
      element of \code{x}. }
    \item{metadata}{\code{signature(x = "QcMetadata")}: return the
      \code{object}'s metadata list. Also available as \code{mdata}. }
    \item{metadata<-}{\code{signature(x = "QcMetadata", value =
	"list")}: sets the objects metadata. Also available as
      \code{mdata}. }
    \item{length}{\code{signature(x = "QcMetadata")}: returns the number
      of metadata variables.}
    \item{names}{\code{signature(x = "QcMetadata")}: returns the names
      of the metadata variables. }    
  }
}


\author{
Laurent Gatto
}


\examples{
QcMetadata(metadata =
           list(name = "John Doe",
                lab = "Big Lab in Big Uni"))
## less typing
qmd <- QcMetadata(list(name = "John Doe",
                       lab = "Big Lab in Big Uni"))
mdata(qmd)
show(qmd)
print(qmd)
}

\keyword{classes}

\name{QcMetrics-class}
\Rdversion{1.1}
\docType{class}
\alias{QcMetrics-class}
\alias{class:QcMetrics}
\alias{QcMetrics}
\alias{[,QcMetrics-method}
\alias{[[,QcMetrics-method}
\alias{length,QcMetrics-method}
\alias{metadata,QcMetrics-method}
\alias{metadata<-,QcMetrics,list-method}
\alias{metadata<-,QcMetrics,QcMetadata-method}
\alias{metadata}
\alias{metadata<-}
\alias{mdata,QcMetrics-method}
\alias{mdata<-,QcMetrics,list-method}
\alias{mdata<-,QcMetrics,QcMetadata-method}
\alias{mdata}
\alias{mdata<-}
\alias{name,QcMetrics-method}
\alias{name<-,QcMetrics,character-method}
\alias{name}
\alias{name<-}
\alias{qcdata,QcMetrics,ANY-method}
\alias{qcdata<-,QcMetrics,list-method}
\alias{show,QcMetrics-method}
\alias{status,QcMetrics-method}
\alias{status<-,QcMetrics,logical-method}
\alias{as.data.frame.QcMetrics}

\title{The \code{"QcMetrics"} class for collections of QC items}

\description{
  Data structure for storing lists of \code{QcMetric} items. 
}

\section{Objects from the Class}{
  Objects can be created using the constructor \code{QcMetrics(...)}, where
  slots are assigned individually. See example below.

  In a standardised quality control pipeline, the \code{QcMetrics} and
  \code{QcMetric} object are not generated manually. Their creation is
  delegated to a wrapper function that reads a specific type of files,
  parses the data, produces the individual \code{QcMetric} instances
  and, eventually, the \code{QcMetric} object. See the package vignette
  for details and examples.
}

\section{Slots}{
  \describe{
    \item{\code{metadata}:}{Object of class
      \code{\linkS4class{QcMetadata}} storing the 
      metadata of the \code{object}. This list would typically contain
      the input file the data was read from, the date the object was
      generated, ... or fully fledged \emph{minimum information}
      descriptions (see \code{\linkS4class{MIAxE}}), when available. }    
    \item{\code{qcdata}:}{Object of class \code{"list"} storing all the
      individual \code{\link{QcMetric}} instances. }
  }
}
\section{Methods}{
  \describe{
    \item{[}{\code{signature(x = "QcMetrics")}: subsets \code{x} as a
      new \code{QcMetrics} instance. }
    \item{[[}{\code{signature(x = "QcMetrics")}: extracts a single
      \code{QcMetric} instance.  }
    \item{length}{\code{signature(x = "QcMetrics")}: returns the number
      of \code{QcMetric} instances populate \code{x}.}
   \item{metadata}{\code{signature(x = "QcMetrics")}: return the
      \code{object}'s metadata list. Also available as \code{mdata}. }
    \item{metadata<-}{\code{signature(x = "QcMetrics", value =
	"list")}: sets the objects metadata. Also available as
      \code{mdata}. }
    \item{metadata<-}{\code{signature(x = "QcMetric", value =
	"QcMetadata")}: sets the objects metadata. Also available as 
      \code{mdata}. }
    \item{name}{\code{signature(object = "QcMetrics")}: returns a
      \code{character} vector of length \code{length(object)} with the names
      of the \code{QcMetric} instances. }
    \item{qcdata}{\code{signature(object = "QcMetrics", x = "missing")}:
      returns a list of all \code{QcMetric} instances. }
    \item{qcdata<-}{\code{signature(object = "QcMetrics", value = "list")}:
      sets the \code{qcdata} of object. }
    \item{show}{\code{signature(object = "QcMetrics")}: prints a short
      textual description of \code{object}. }
    \item{status}{\code{signature(object = "QcMetrics")}: returns a
      vector of quality statuses (\code{logicals}).}
    \item{status<-}{\code{signature(object = "QcMetrics", value =
	"logical")}: sets the quality statuses. Length of \code{value}
      and \code{object} must be identical. }    
    \item{as}{\code{signature(object = "QcMetrics", "data.frame")}:
      coerces \code{object} as a \code{length(object)} by 2 data frame
      with the respective \code{QcMetric} instances names and statuses. } 
    \item{qcReport}{\code{signature(object = "QcMetrics")}: ... }
  }
}

\author{
  Laurent Gatto
}


\seealso{
  The \code{\link{QcMetric}} class for individual QC items.
}

\examples{
example(QcMetric)
show(qc)

qc2 <- QcMetric(name = "My other metric", status = TRUE)
qcdata(qc2, "x") <- rnorm(100)
qcdata(qc2, "k") <- rep(LETTERS[1:2], 50)

plot(qc2) <- function(object, ...) {
    require("lattice")
    d <- data.frame(x = qcdata(object, "x"),
                    k = qcdata(object, "k"))
    bwplot(x ~ k, data = d)
}

qcm <- QcMetrics(qcdata = list(qc, qc2))
qcm

qcm[1] ## a QcMetrics instance
qcm[[1]] ## a single QcMetric

metadata(qcm)
metadata(qcm) <- QcMetadata(list(name = "Prof. Who",
                                 lab = "Cabin University"))
## or, shorter but equivalent
metadata(qcm) <- list(name = "Prof. Who",
                      lab = "Cabin University")
metadata(qcm) ## or mdata(qcm)
## update metadata
metadata(qcm) <- list(lab = "Big lab", ## updated
                      uni = "Cabin University") ## added
mdata(qcm)
}

\keyword{classes}

\name{qcReport-methods}
\docType{methods}
\alias{qcReport-methods}
\alias{qcReport,QcMetrics-method}
\alias{qcReport}
\alias{reporting}
\alias{reporting_pdf}
\alias{reporting_tex}
\alias{reporting_rmd}
\alias{reporting_html}
\alias{example_reports}

\title{ Automatic report generation }

\description{
  The \code{qcReport} method generates report in various formats taking
  a \code{\linkS4class{QcMetrics}} instance as input. Each individual
  quality control item produces a section with description of the item
  and a assessment figure.
}


\details{

  The reporting functions take a \code{QcMetrics} instance as input,
  generate the source of the report and compile it into the final format
  that are currently available are \code{reporting_pdf},
  \code{reporting_tex}, \code{reporting_rmd} and \code{reporting_html}.
  See \code{\link{qcto}} for details about the sectioning functions,
  that convert individual \code{QcMetric} objects into adequate report
  sections.

  The package vignette documents the report generation in more details
  and describes possibilities for customisation.
}

\section{Methods}{
  \describe{
    \item{\code{signature(
        object = "QcMetrics",
        reportname = "character",
        type = "character",
        author = "character",
        title = "character",
        metadata = "logical",
        toc = "logical",
        summary = "logical",
        sessioninfo = "logical",
        clean = "logical",
        quiet = "logical",
        reporter,
        qcto,
        ...)}}{
      generates a report for the \code{\link{QcMetrics}}
      \code{object}. The report will be named according the
      \code{reportname} (default is \code{qcreprt})and \code{type}, the
      latter defining the output format and the extension. Possible
      types are \code{pdf} (default), "tex", "Rmd", "html" (all
      generated using the package \code{knitr}). A custom \code{title}
      can be provided; default is "Quality control report generated with
      qcmetrics". If no \code{author} is provided, the default value
      (\code{Sys.getenv("USER")}) is used. The addition of a table of
      contents (default is \code{FALSE}), a metadata section, a summary
      section and the session information can be controlled with the
      \code{toc}, \code{metadata}, \code{summary} and
      \code{sessioninformation} arguments. The metadata section is
      added to the report when present and the other have \code{TRUE} as
      default.

      Intermediate files are deleted, unless \code{clean} is set to
      \code{FALSE} and verbose output can be turned on by setting
      \code{quiet} to \code{FALSE}.

      The \code{reporter} and \code{qcto} arguments are used to convert
      \code{QcMetric} and \code{QcMetrics} objects into report
      source. See Details and the package vignette for details.

      Addition parameters can be passed to inner functions. For the
      \code{pdf} report, passed to \code{texi2pdf}; for \code{html},
      passed to \code{markdown::markdownToHTML}.

      The method invisibly returns the name of the report that was
      generated.
    }
  }
}

\examples{
example(QcMetrics)
show(qcm)

destdir <- tempdir()
(report <- file.path(destdir, "testQCReport"))


\dontrun{
  ## pdf report
  qcReport(qcm, reportname = report)
  ## use pdflatex to generate the pdf file
  qcReport(qcm, reportname = report, texi2dvi = "pdflatex")
}

## default html report
html <- qcReport(qcm, reportname = report, type = "html")
html
if (interactive())
    browseURL(html)
}

\keyword{methods}
\keyword{report}

\name{Qc2Tex}
\alias{Qc2Tex}
\alias{Qc2Tex2}
\alias{Qc2Tex3}
\alias{Qc2Rmd}
\alias{qcto}

\title{ 'QcMetric' sectioning functions }

\description{
  These functions convert the \code{i}th \code{QcMetric} instance of the
  \code{QcMetrics} object into a section of the adequate format,
  i.e. TeX of R markdown.
}

\usage{
Qc2Tex(object, i)
Qc2Tex2(object, i)
Qc2Tex3(object, i)
Qc2Rmd(object, i)
}


\arguments{
  \item{object}{An instance of class \code{QcMetrics} with at least one
  QC item. }
  \item{i}{
    A \code{numeric} of length 1 indicating the index of the item to be
    converted into text section. 
  }
}

\value{
  A \code{character} representing the QC item section.
}


\author{
  Laurent Gatto
}

\seealso{
  \code{\link{qcReport}} and the vignette.
}

\name{QcMetric-class}
\Rdversion{1.1}
\docType{class}
\alias{class:QcMetric}
\alias{QcMetric-class}
\alias{QcMetric}
\alias{name<-,QcMetric,character-method}
\alias{name,QcMetric-method}
\alias{description<-,QcMetric,character-method}
\alias{description,QcMetric-method}
\alias{plot,QcMetric,missing-method}
\alias{plot<-,QcMetric,function-method}
\alias{plot<-}
\alias{qcenv,QcMetric-method}
\alias{qcenv<-,QcMetric,environment-method}
\alias{qcenv}
\alias{qcenv<-}
\alias{qcdata<-,QcMetric,ANY-method}
\alias{qcdata,QcMetric,character-method}
\alias{qcdata,QcMetric,missing-method}
\alias{qcdata}
\alias{qcdata<-}
\alias{qcshow}
\alias{show,QcMetric-method}
\alias{show<-,QcMetric,function-method}
\alias{show<-}
\alias{status<-,QcMetric,logical-method}
\alias{status,QcMetric-method}
\alias{status}
\alias{status<-}


\title{The \code{"QcMetric"} class for QC items}

\description{
  Data structure for individual QC metrics items.
}

\section{Objects from the Class}{
  Objects can be created using the constructor \code{QcMetric(...)}, where
  slots are assigned individually. See example below.
}
\section{Slots}{
  \describe{
    \item{\code{name}:}{Object of class \code{"character"} of length 1
      naming the \code{object}. }
    \item{\code{description}:}{Object of class \code{"character"} of
      arbitrary length describing the qc metric in more details. }
    \item{\code{qcdata}:}{Object of class \code{"environment"} that
      stores the actual data. }
    \item{\code{plot}:}{Object of class \code{"function"} to graphically
      represent the data and infer quality status. }
    \item{\code{show}:}{Object of class \code{"function"} to print a
      short textual representation of the \code{object}. A reasonable
      default value is provided. }
    \item{\code{status}:}{Object of class \code{"logical"} that
      indicates weather the data passes (\code{TRUE}) or fails
      (\code{FALSE}) the metric or has not yet been evaluated. }
  }
}

\section{Methods}{
  \describe{
    \item{name}{\code{signature(object = "QcMetric")}: retrieves the
      name of the \code{object}. }
    \item{name<-}{\code{signature(object = "QcMetric", value =
        "character")}: set the name of the \code{object}. }
    \item{description}{\code{signature(object = "QcMetric")}: retrieves the
      description of the \code{object}. }
    \item{description<-}{\code{signature(object = "QcMetric", value =
        "character")}: set the description of the \code{object}. }
    \item{status}{\code{signature(object = "QcMetric")}: retrieves the
      status of the \code{object}. }
    \item{status<-}{\code{signature(object = "QcMetric", value =
        "logical")}: sets the status of the \code{object}s. }
    \item{qcdata}{\code{signature(object = "QcMetric", x = "missing")}:
      lists all the data \code{object}s that are associated with the
      \code{object}s. }
    \item{qcdata}{\code{signature(object = "QcMetric", x =
        "character")}: retrieves the variable \code{x} for the
      \code{object}. }
    \item{qcdata<-}{\code{signature(object = "QcMetric", var)}: creates
      or overwrites (with a message) the data variable \code{var} by
      assigning the RHS value. If \code{var} is missing and the RHS
      expression is an environment, then \code{qcdata} is reset with all
      the variables in \code{value}. }
    \item{qcenv}{\code{signature(object = "QcMetric")}: return the
      \code{environment} that stores the QC data. }
    \item{qcenv<-}{\code{signature(object = "QcMetric")}:
      Set all variable in the RHS \code{environment} as \code{qcdata}
      variables. Equivalent to \code{qcdata(object) <- x} where \code{x}
      is an environment. }
    \item{show}{\code{signature(object = "QcMetric")}: shows a textual
      summary of \code{object}. The default \code{show} implementation
      is available as the \code{qcshow{object, qcdata}} function. The
      second argument is a logical (default is \code{TRUE}) that
      specifies whether \code{qcdata(object)} should be displayed. }
    \item{show<-}{\code{signature(object = "QcMetric", value =
        "function")}: sets a custom \code{show} method for
      \code{object}. }
    \item{plot}{\code{signature(x = "QcMetric", y = "missing")}: plots
      the \code{object} using the provide \code{show} method. }
    \item{plot<-}{\code{signature(object = "QcMetric", value =
        "function")}: sets a custom \code{plot} method for
      \code{object}. }
    \item{qcReport}{\code{signature(x = "QcMetric", ...)}: to generate
      quality reports. See \code{\link{qcReport}} for details. }
  }
}

\author{
  Laurent Gatto
}


\seealso{
  The \code{\link{QcMetrics}} class to bundle a set of
  \code{QcMetric} instances.
}
\examples{
(qc <- QcMetric())
qcdata(qc)
try(qcdata(qc, "x"))

x <- rnorm(10)
qcdata(qc, "qc1") <- x
qcdata(qc, "qc2") <- 1:10
qcdata(qc)
all.equal(qcdata(qc, "qc1"), x)
all.equal(qcdata(qc, "qc2"), 1:10)
name(qc) <- "My test QcMetric"
description(qc) <- "This qc metric describes bla bla bla, indicating possible issues in the third step of protocol bla bla bla."
status(qc) <- FALSE
qc

## or
e <- new.env()
e$qc1 <- rnorm(100)
e$qc2 <- 1:100
qcenv(qc) <- e
length(qcdata(qc, "qc1"))
head(qcdata(qc, "qc2"))

show(qc)
show(qc) <- function(object) cat("Updated show method\n")
show(qc)
show(qc) <- qcshow
qc


plot(qc)
plot(qc) <-
    function(object, ...)
        plot(qcdata(object, "qc2"),
             qcdata(object, "qc1"),
             xlab = "qc1",
             ylab = "qc2",
             ...)
plot(qc)
plot(qc, col = "red", pch = 19)

}

\keyword{classes}
